#!/usr/bin/perl -w

# Copyright 2018, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  See the file COPYING.  If not, see
# <http://www.gnu.org/licenses/>.

use 5.010;
use strict;

{
  # semitotdomnum states
  my @table = (
[ 1, 2, 3, 4, 5, 6, 7, 8, 9, 5,11,12,13, 5,15,16, 6,18,16,20,16,],
[10,14,17,19,undef,undef,19,undef,19,undef,undef,undef,19,undef,undef,undef,undef,undef,undef,undef,undef,],
[14,undef,undef,undef, 2,undef,undef,undef,undef, 2,undef,undef,undef, 2,undef, 2,undef,undef, 2,undef, 2,],
[17,undef,undef, 3,undef,undef,undef,undef,undef,undef,undef,undef,undef,undef, 3, 3,undef,undef, 3,undef, 3,],
[19,undef, 3, 4,13, 8, 9, 8, 9,13,undef,12,13,13,15, 4, 8,18, 4,20, 4,],
[undef, 2,undef,13, 5, 8, 7, 8, 9, 5,11,undef,13, 5,undef, 5, 8,undef, 5,20, 5,],
[undef,undef,undef, 8, 8,undef, 8,undef, 8, 8,undef,undef, 8, 8,undef, 8,undef,undef,undef,undef, 8,],
[19,undef,undef, 9, 7, 8, 9, 8, 9, 7,undef,undef, 9, 7,20, 7, 8,undef, 7,20, 7,],
[undef,undef,undef, 8, 8,undef, 8,undef, 8, 8,undef,undef, 8, 8,undef, 8,undef,undef,undef,undef, 8,],
[19,undef,undef, 9, 9, 8, 9, 8, 9, 9,undef,undef, 9, 9,20, 9, 8,undef, 9,20, 9,],
[10,undef,undef,undef,undef,10,undef,undef,undef,undef,undef,undef,undef,undef,undef,undef,10,undef,undef,undef,undef,],
[undef,undef,undef,undef,11,undef,undef,undef,undef,11,undef,undef,undef,11,undef,11,undef,undef,11,undef,11,],
[undef,undef,undef,12,undef,undef,undef,undef,undef,undef,undef,undef,undef,undef, 3,12,undef,undef,12,undef,12,],
[19,undef,undef,13,13, 8, 9, 8, 9,13,undef,undef,13,13,undef,13, 8,undef,13,20,13,],
[undef,14,undef,14,14,undef,14,undef,14,14,14,undef,14,14,14,14,undef,14,14,14,14,],
[undef,undef, 3,15,undef,undef,20,undef,20,undef,undef, 3,undef,undef,15,15,undef,18,15,20,15,],
[undef, 2, 3, 4, 5, 8, 7, 8, 9, 5,11,12,13, 5,15,16, 8,18,16,20,16,],
[undef,undef,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,],
[undef,undef,undef,18,undef,undef,undef,undef,undef,undef,undef,undef,undef,undef,18,18,undef,18,18,undef,18,],
[undef,14,17,19,19,undef,19,undef,19,19,undef,undef,19,19,undef,19,undef,undef,undef,undef,19,],
[undef,undef,undef,20,20,undef,20,undef,20,20,undef,undef,20,20,20,20,undef,undef,20,20,20,],
,

);
  require MyFLAT;
  my $f = MyFLAT::aref_to_FLAT_DFA(\@table,
                                   starting => 0,
                                   accepting_list =>
[0,1,2,5,7,10,11,16,],
);
  $f->MyFLAT::view;
  # $f = $f->MyFLAT::minimize (verbose=>1);
  # $f->MyFLAT::view;
  exit 0;
}
