\\ Copyright 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
\\ default(parisizemax,300*10^6);
read("../vpar.gp");
read("../vpar-wip.gp");
read("memoize.gp");
setrand(getwalltime()%2^32);


progress_prev=-1;
progress(str) =
{
  my(t=getwalltime()\2000);
  if(t!=progress_prev,
     progress_prev=t;
     print(str));
}

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong: "name);
     print("got  "got);
     print("want "want);
     quit(1),
     option_verbose,
     print("ok "check_count" "name));
}


\\------------------------------------------------------------------------------

try_seq_upascend(vpar) =
{
  \\ WRONG
  print("vpar_from_upascend() "vec);
  my(max_child=vpar_minmax_child_vector(vec,max),
     vpar=vector(#vec),
     upto=0);  \\ position in vec[]
  for(i=1,#vec,
     print("i="i" max_child "max_child[i]"  upto="upto);
     my(v=i);
     while(max_child[v] <= upto,
           my(p=vec[upto++]);  \\ pre-increment
           print("  vpar store v="v" p="p" new upto="upto);
           (vpar[v]=p) || break();
           v=p;
           (ahead || v<=i) || break());
  );
  vpar;
}


